Index: tests/.expect/manipulatorsOutput3.x64.txt
===================================================================
--- tests/.expect/manipulatorsOutput3.x64.txt	(revision ccb776b460be3a146c8fa7ddd58eaea3add21af3)
+++ tests/.expect/manipulatorsOutput3.x64.txt	(revision 61ce21419e1e9f10bc28013bf9650f22ac59775b)
@@ -3,4 +3,5 @@
 +1208907372870555465220095
 
+base 2
 0b11111111111111110000000000000000000000000000000000000000000000001111111111111111
 0B11111111111111110000000000000000000000000000000000000000000000001111111111111111
@@ -10,4 +11,13 @@
 0X0000000000FFFF000000000000FFFF
 
+0b1001011001110110101011000110010011111001100011011000100011110100000000000000000
+0B1001011001110110101011000110010011111001100011011000100011110100000000000000000
+0B1001011001110110101011000110010011111001100011011000100011110100000000000000000
+0B1001011001110110101011000110010011111001100011011000100011110100000000000000000
+0B1001011001110110101011000110010011111001100011011000100011110100000000000000000
+0B1001011001110110101011000110010011111001100011011000100011110100000000000000000
+0B1001011001110110101011000110010011111001100011011000100011110100000000000000000
+
+base 8
 0000000123
 0000000123
@@ -42,4 +52,27 @@
 03777777777777777777777777777777777776543211Y
 
+0113166530623714330436400000
+          0113166530623714330436400000
+            0113166530623714330436400000
+  00000000000113166530623714330436400000
+          000113166530623714330436400000
+  00000000000113166530623714330436400000
+
+base 10
+355272055279601493606400
+355272055279601493606400
+355272055279601493606400
+355272055279601493606400
+355272055279601493606400
+              355272055279601493606400
+               355272055279601493606400
+                355272055279601493606400
+          000000355272055279601493606400
+  00000000000000355272055279601493606400
+0000000000000000355272055279601493606400
+0000000000000000355272055279601493606400
++000000000000000355272055279601493606400
+
+base 16
 0xffff000000000000ffff
 0XFFFF000000000000FFFF
@@ -52,37 +85,4 @@
 0X00000000000000000000000000000FFFF000000000000FFFFX
 
-base 2
-0b1001011001110110101011000110010011111001100011011000100011110100000000000000000
-0B1001011001110110101011000110010011111001100011011000100011110100000000000000000
-0B1001011001110110101011000110010011111001100011011000100011110100000000000000000
-0B1001011001110110101011000110010011111001100011011000100011110100000000000000000
-0B1001011001110110101011000110010011111001100011011000100011110100000000000000000
-0B1001011001110110101011000110010011111001100011011000100011110100000000000000000
-0B1001011001110110101011000110010011111001100011011000100011110100000000000000000
-
-base 8
-0113166530623714330436400000
-          0113166530623714330436400000
-            0113166530623714330436400000
-  00000000000113166530623714330436400000
-          000113166530623714330436400000
-  00000000000113166530623714330436400000
-
-base 10
-355272055279601493606400
-355272055279601493606400
-355272055279601493606400
-355272055279601493606400
-355272055279601493606400
-              355272055279601493606400
-               355272055279601493606400
-                355272055279601493606400
-          000000355272055279601493606400
-  00000000000000355272055279601493606400
-0000000000000000355272055279601493606400
-0000000000000000355272055279601493606400
-+000000000000000355272055279601493606400
-
-base 16
 0X4B3B56327CC6C47A0000
                 0X4B3B56327CC6C47A0000
@@ -108,4 +108,122 @@
 +0000000000000000355272055279601493606400X
 +0000000000000000000000000000000123456789X
+-1000 0xfffffffffffffffffffffffffffffc18 03777777777777777777777777777777777777776030
+0b11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111110000011000
+-999 0xfffffffffffffffffffffffffffffc19 03777777777777777777777777777777777777776031
+0b11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111110000011001
+-998 0xfffffffffffffffffffffffffffffc1a 03777777777777777777777777777777777777776032
+0b11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111110000011010
+-997 0xfffffffffffffffffffffffffffffc1b 03777777777777777777777777777777777777776033
+0b11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111110000011011
+-996 0xfffffffffffffffffffffffffffffc1c 03777777777777777777777777777777777777776034
+0b11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111110000011100
+-995 0xfffffffffffffffffffffffffffffc1d 03777777777777777777777777777777777777776035
+0b11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111110000011101
+-994 0xfffffffffffffffffffffffffffffc1e 03777777777777777777777777777777777777776036
+0b11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111110000011110
+-993 0xfffffffffffffffffffffffffffffc1f 03777777777777777777777777777777777777776037
+0b11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111110000011111
+-992 0xfffffffffffffffffffffffffffffc20 03777777777777777777777777777777777777776040
+0b11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111110000100000
+-991 0xfffffffffffffffffffffffffffffc21 03777777777777777777777777777777777777776041
+0b11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111110000100001
+
+
+-990                                                                                                                                                            
+-990
+0xfffffffffffffffffffffffffffffc22
+03777777777777777777777777777777777777776042
+0b11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111110000100010
+-990
+0xfffffffffffffffffffffffffffffc22
+03777777777777777777777777777777777777776042
+0b11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111110000100010
+-990                            
+0xfffffffffffffffffffffffffffffc22
+03777777777777777777777777777777777777776042
+0b11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111110000100010
+-990                                                                                                                                                            
+0xfffffffffffffffffffffffffffffc22                                                                                                                              
+03777777777777777777777777777777777777776042                                                                                                                    
+0b11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111110000100010                              
+-990                                                                                                                                                            
+0XFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC22                                                                                                                              
+03777777777777777777777777777777777777776042                                                                                                                    
+0B11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111110000100010                              
+22763282186957586699822X
+                   04644000000000000000013056X
+04644000000000000000013056                   X
+                   04644000000000000000013056X
+04644000000000000000013056                   X
+                   04644000000000000000013056X
+04644000000000000000013056                   X
+         000000000004644000000000000000013056X
+000000000004644000000000000000013056         X
+0000000000000000000004644000000000000000013056X
+0000000000000000000004644000000000000000013056X
+04644000000000000000013056                   X
+04644000000000000000013056                   X
+04644000000000000000013056                   X
+04644000000000000000013056                   X
+0004644000000000000000013056                 X
+03777777777777777773133777777777777777764722Y
+03777777777777777773133777777777777777764722Y
+03777777777777777773133777777777777777764722Y
+03777777777777777773133777777777777777764722Y
+03777777777777777773133777777777777777764722Y
+03777777777777777773133777777777777777764722Y
+03777777777777777773133777777777777777764722 Y
+0000003777777777777777773133777777777777777764722Y
+03777777777777777773133777777777777777764722 Y
+0123                                         X
+04644000000000000000013056                   X
+0000000000000000000000000000000000000123     X
+0000000000000004644000000000000000013056     X
+000000000000000000000000000000000000000000123X
+000000000000000000004644000000000000000013056X
+0000000123                              X
+04644000000000000000013056              X
+03777777777777777773133777777777777777764722X
+0000000000000000000000000000000000000123X
+0000000000000004644000000000000000013056X
+03777777777777777773133777777777777777764722X
+1777777777777777777777
+2777777777777777777777
+3777777777777777777777
+4777777777777777777777
+5777777777777777777777
+6777777777777777777777
+7777777777777777777777
+10777777777777777777777
+0b11111111111111110000000000000000000000000000000000000000000000001111111111111111
+0B11111111111111110000000000000000000000000000000000000000000000001111111111111111
+11111111111111110000000000000000000000000000000000000000000000001111111111111111
+             0B11111111111111110000000000000000000000000000000000000000000000001111111111111111
+   0B000000000011111111111111110000000000000000000000000000000000000000000000001111111111111111
+0B00000000000000011111111111111110000000000000000000000000000000000000000000000001111111111111111
+0b11111111111111110000000000000000000000000000000000000000000000001111111111111111
+0B11111111111111110000000000000000000000000000000000000000000000001111111111111111
+11111111111111110000000000000000000000000000000000000000000000001111111111111111
+0B11111111111111110000000000000000000000000000000000000000000000001111111111111111             
+0B000000000011111111111111110000000000000000000000000000000000000000000000001111111111111111   
+0B011111111111111110000000000000000000000000000000000000000000000001111111111111111            
+0B11111111111111110000000000000000000000000000000000000000000000001111111111111111             
+0B11111111111111110000000000000000000000000000000000000000000000001111111111111111             
+0B000000000000000000000000000000000000000000000000000000000000000000000000001111111111111111   
+0B0000000000000000000000000000000000000000000000001111111111111111  
+0B00000000000000011111111111111110000000000000000000000000000000000000000000000001111111111111111
+   0X000000000000000000000FFFF
+   0X000000000000000000000FFFF
+0X00000000000000000000000000FFFF
+0X00000000000000000000000000FFFF
+05000000000000000000123
+                      05000000000000000000123
+05000000000000000000123                      X
+0000000123                              X
+0377776000000000000000177777            X
+05000000000000000000123                 X
+0000000000000000000000000000000000000123X
+0000000000000377776000000000000000177777X
+0000000000000000005000000000000000000123X
 -10                  0xfffffffffffffffffffffffffffffff6 03777777777777777777777777777777777777777766
 0b11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111110110
@@ -261,2 +379,59 @@
 12
 13
+0xfffffffffffffffffffe
+0xfffffffffffffffffffe
+
+binary
+0b11111111111111111111111111111111111111111111111111111111111111111111111111111110
+0b11111111111111111111111111111111
+0b1111111111111111111111111111111111111111111111111111111111111111
+0b111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
+0b11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
+0xa2345678
+0xa2345678a7654321
+0xa2345678a7654321c2345678
+0xa2345678a7654321c2345678d7554321
+
+octal
+0377777777777777777777777776
+0123456
+012345665432
+01234566543234567
+0123456654323456776543
+012345665432345677654323456
+01234566543234567765432345665432
+0123456654323456776543234566543234567
+012345665432345677654323456654323456776543
+01111111111111111111
+011111111111111111111
+0111111111111111111111
+
+decimal
+1208925819614629174706174
+42798 0123456
+1402432282 012345665432
+45954901031287 01234566543234567
+1505850196993244515 0123456654323456776543
+394749758663249135511342 0123456665432345677654323456
+12935154696204706112391834394 012345665432234567765432345665432
+423859149128410414395372834994551 01234566543234567776543234566543234567
+13889016598639747063234935497057631587 0123456654323456776543323456654323456776543
+1234567890123456789
+1234567890123456789
+170141183460469231731687303715884105727
+340282366920938463463374607431768211455
+9223372036854775808
+340282366920938463463374607431768211455
+170141183460469231731687303715884105727
+
+hexadecimal
+0xfffffffffffffffffffe
+0xffffffff
+0xffffffffffffffff
+0xffffffffffffffffffffffff
+0xffffffffffffffffffffffffffffffff
+0xa2345678
+0xa2345678b7654321
+0xa2345678b7654321c2345678
+0xa2345678b7654321c2345678d7654321
+
Index: tests/manipulatorsOutput3.cfa
===================================================================
--- tests/manipulatorsOutput3.cfa	(revision ccb776b460be3a146c8fa7ddd58eaea3add21af3)
+++ tests/manipulatorsOutput3.cfa	(revision 61ce21419e1e9f10bc28013bf9650f22ac59775b)
@@ -2,5 +2,7 @@
 
 int main() {
+	// int128 printing
 	int128 x = 0xffff, y = 0x2;
+
 	x <<= 64;
 	x += 0xffff;
@@ -15,4 +17,10 @@
 	sout | nl;
 
+	int128 divisor = 0x4b3b4ca85a86c47a;
+	divisor <<= 16;
+	divisor += 0x98a224000000000;
+	
+	// base 2
+	sout | "base 2";
 	sout | bin(x);
 	sout | upcase(bin(x));
@@ -23,4 +31,15 @@
 	sout | nl;
 
+	sout | bin(divisor);
+	sout | upcase(bin(divisor));
+	sout | wd(38, upcase(bin(divisor)));
+	sout | wd(40, upcase(bin(divisor)));
+	sout | wd(40, 38, upcase(bin(divisor)));
+	sout | wd(40, 30, upcase(bin(divisor)));
+	sout | pad0(sign(wd(40, 38, upcase(bin(divisor)))));
+	sout | nl;
+	
+	// oct
+	sout | "base 8";
 	printf( "%#.10o\n", 0123 );
 	sout | wd( 1,10, oct(0123) );
@@ -60,33 +79,4 @@
 	sout | nl;
 
-	sout | hex(x);
-	sout | upcase(hex(x));
-	sout | nobase(hex(x));
-	sout | wd( 45, upcase(hex(x)) );
-	sout | wd( 45,40, upcase(hex(x)) );
-	sout | wd( 45,49, upcase(hex(x)) );
-	sout | left(wd( 45, upcase(hex(x)) )) | 'X';
-	sout | left(wd( 45,40, upcase(hex(x)) )) | 'X';
-	sout | left(wd( 45,49, upcase(hex(x)) )) | 'X';
-
-	sout | nl;
-
-	int128 divisor = 0x4b3b4ca85a86c47a;
-	divisor <<= 16;
-	divisor += 0x98a224000000000;
-	
-	// base 2
-	sout | "base 2";
-	sout | bin(divisor);
-	sout | upcase(bin(divisor));
-	sout | wd(38, upcase(bin(divisor)));
-	sout | wd(40, upcase(bin(divisor)));
-	sout | wd(40, 38, upcase(bin(divisor)));
-	sout | wd(40, 30, upcase(bin(divisor)));
-	sout | pad0(sign(wd(40, 38, upcase(bin(divisor)))));
-	sout | nl;
-	
-	// oct
-	sout | "base 8";
 	sout | upcase(oct(divisor));
 	sout | wd(38, upcase(oct(divisor)));
@@ -117,4 +107,16 @@
 	// hex
 	sout | "base 16";
+
+	sout | hex(x);
+	sout | upcase(hex(x));
+	sout | nobase(hex(x));
+	sout | wd( 45, upcase(hex(x)) );
+	sout | wd( 45,40, upcase(hex(x)) );
+	sout | wd( 45,49, upcase(hex(x)) );
+	sout | left(wd( 45, upcase(hex(x)) )) | 'X';
+	sout | left(wd( 45,40, upcase(hex(x)) )) | 'X';
+	sout | left(wd( 45,49, upcase(hex(x)) )) | 'X';
+	sout | nl;
+
 	sout | upcase(hex(divisor));
 	sout | wd(38, upcase(hex(divisor)));
@@ -124,5 +126,4 @@
 	sout | pad0(sign(wd(40, 38, upcase(hex(divisor)))));
 	sout | nl;
-
 
 	// extras
@@ -146,24 +147,152 @@
 	int128 i128;
 	unsigned int128 ui128;
+	i128 = -1000;
+	for ( 10 ) {
+		sout | left( sign( wd( 2, i128 ) ) ) | left( wd( 2, hex( i128 ) ) ) | left( wd( 2, oct( i128 ) ) );
+		sout | left( wd( 2, bin( i128 ) ) );
+		i128 += 1;
+	}
+	sout | nl;
+	sout | nl;
+
+	ui128 = 0x7fffffffffffffff;
+	ui128 <<= 64;
+	ui128 += 0xffffffffffffffff;
+	sout | left( wd( 160, i128 ) );
+	sout | left( sign( wd( 0, i128 ) ) );
+	sout | left( wd( 0, hex( i128 ) ) );
+	sout | left( wd( 0, oct( i128 ) ) );
+	sout | left( wd( 0, bin( i128 ) ) );
+	sout | left( sign( wd( 1, i128 ) ) );
+	sout | left( wd( 1, hex( i128 ) ) );
+	sout | left( wd( 1, oct( i128 ) ) );
+	sout | left( wd( 1, bin( i128 ) ) );
+	sout | left( sign( wd( 32, i128 ) ) );
+	sout | left( wd( 32, hex( i128 ) ) );
+	sout | left( wd( 32, oct( i128 ) ) );
+	sout | left( wd( 32, bin( i128 ) ) );
+	sout | left( sign( wd( 160, i128 ) ) );
+	sout | left( wd( 160, hex( i128 ) ) );
+	sout | left( wd( 160, oct( i128 ) ) );
+	sout | left( wd( 160, bin( i128 ) ) );
+	sout | left( sign( wd( 160, i128 ) ) );
+	sout | left( wd( 160, upcase(hex( i128 )) ) );
+	sout | left( wd( 160, upcase(oct( i128 ) )) );
+	sout | left( wd( 160, upcase(bin( i128 )) ) );
+
+	x = 1234;
+	x <<= 64;
+	x += 5678;
+	sout | x | 'X';
+	sout | wd(45, 20, oct(x)) | 'X';
+	sout | left(wd(45, 20, oct(x))) | 'X';
+	sout | wd(45, 21, oct(x)) | 'X';
+	sout | left(wd(45, 21, oct(x))) | 'X';
+	sout | wd(45, 22, oct(x)) | 'X';
+	sout | left(wd(45, 22, oct(x))) | 'X';
+	sout | wd(45, 36, oct(x)) | 'X';
+	sout | left(wd(45, 36, oct(x))) | 'X';
+	sout | wd(45, 46, oct(x)) | 'X';
+	sout | left(wd(45, 46, oct(x))) | 'X';
+	sout | left(wd(45, 20, oct(x))) | 'X';
+	sout | left(wd(45, 22, oct(x))) | 'X';
+	sout | left(wd(45, 24, oct(x))) | 'X';
+	sout | left(wd(45, 26, oct(x))) | 'X';
+	sout | left(wd(45, 28, oct(x))) | 'X';
+
+	y = -x;
+	sout | oct(y) | 'Y';
+	sout | left(wd(0, oct(y))) | 'Y';
+	sout | left(wd(20, oct(y))) | 'Y';
+	sout | left(wd(26, oct(y))) | 'Y';
+	sout | left(wd(40, oct(y))) | 'Y';
+	sout | left(wd(41, oct(y))) | 'Y';
+	sout | left(wd(45, oct(y))) | 'Y';
+	sout | left(wd(45, 49, oct(y))) | 'Y';
+	sout | left(wd(45, 4, oct(y))) | 'Y';
+	sout | left(wd( 45, oct(0123) )) | 'X';
+	sout | left(wd( 45, oct(x) )) | 'X';
+	sout | left(wd( 45,40, oct(0123) )) | 'X';
+	sout | left(wd( 45,40, oct(x) )) | 'X';
+	sout | left(wd( 40,45, oct(0123) )) | 'X';
+	sout | left(wd( 40,45, oct(x) )) | 'X'; 
+	sout | left(wd( 40,10, oct(0123) )) | 'X';
+	sout | left(wd( 40,10, oct(x) )) | 'X';
+	sout | left(wd( 40,10, oct(y) )) | 'X';
+	sout | left(wd( 10,40, oct(0123) )) | 'X';
+	sout | left(wd( 10,40, oct(x) )) | 'X';
+	sout | left(wd( 10,40, oct(y) )) | 'X';
+
+	x = 0xffff, y = 0x2;
+	int128 z = 0x_ffff_ffff_ffff_ffff;
+	x <<= 64;
+	x += 0xffff;
+	y <<= 64;
+	y += 0123;
+	y |= 0x8000000000000000;
+
+	for ( int128 i = 0; i < 8; i += 1 ) {
+		sout | nobase(oct(z + 0x8000000000000000 * i));
+	} // for
+
+	sout | bin(x);
+	sout | upcase(bin(x));
+	sout | nobase(bin(x));
+
+	sout | wd( 95, upcase(bin(x)) );
+	sout | wd( 95,90, upcase(bin(x)) );
+	sout | wd( 90,95, upcase(bin(x)) );
+
+	sout | left(bin(x));
+	sout | left(upcase(bin(x)));
+	sout | left(nobase(bin(x)));
+
+	sout | left(wd( 95, upcase(bin(x)) ));
+	sout | left(wd( 95,90, upcase(bin(x)) ));
+	sout | left(wd( 95,81, upcase(bin(x)) ));
+
+	sout | left(wd( 95,80, upcase(bin(x)) ));
+	sout | left(wd( 95,79, upcase(bin(x)) ));
+	sout | left(wd( 95,90, upcase(bin(0xffff)) ));
+
+	sout | left(wd( 68,64, upcase(bin(0xffff)) ));
+	sout | left(wd( 90,95, upcase(bin(x)) ));
+
+	printf( "%#30.25X\n", 0xffff );
+	sout | wd( 30,25, upcase(hex(0xffff)) );
+	printf( "%#25.30X\n", 0xffff );
+	sout | wd( 25,30, upcase(hex(0xffff)) );
+
+	sout | oct(y);
+	sout | wd( 45, oct(y) );
+	sout | left(wd( 45, oct(y) )) | 'X';
+
+	sout | left(wd( 40,10, oct(0123) )) | 'X';
+	sout | left(wd( 40,10, oct(x) )) | 'X';
+	sout | left(wd( 40,10, oct(y) )) | 'X';
+	sout | left(wd( 10,40, oct(0123) )) | 'X';
+	sout | left(wd( 10,40, oct(x) )) | 'X';
+	sout | left(wd( 10,40, oct(y) )) | 'X';
 
 	i128 = -10;
 	for ( 25 ) {
-	sout | left( sign( wd( 20, i128 ) ) ) | left( wd( 20, hex( i128 ) ) ) | left( wd( 20, oct( i128 ) ) );
-	sout | left( wd( 20, bin( i128 ) ) );
-	i128 += 1;
-	}
-	sout | nl;
+		sout | left( sign( wd( 20, i128 ) ) ) | left( wd( 20, hex( i128 ) ) ) | left( wd( 20, oct( i128 ) ) );
+		sout | left( wd( 20, bin( i128 ) ) );
+		i128 += 1;
+	} // for
+	sout | nl;
+
 	i128 = 0x7fffffffffffffff;
 	i128 <<= 64;
 	i128 += 0xfffffffffffffffa;
 
-//    for ( 20 ) {
-	volatile int stop = 20;
+//	for ( 20 ) {
+	volatile int stop = 20;								// gcc compiler bug
 	for ( int i = 0; i < stop; i += 1 ) {
-	sout | i128;
-	sout | left( sign( wd( 45, i128 ) ) ) | left( wd( 45, hex( i128 ) ) ) | left( wd( 45, oct( i128 ) ) );
-	sout | left( wd( 45, bin( i128 ) ) );
-	i128 += 1;
-	}
+		sout | i128;
+		sout | left( sign( wd( 45, i128 ) ) ) | left( wd( 45, hex( i128 ) ) ) | left( wd( 45, oct( i128 ) ) );
+		sout | left( wd( 45, bin( i128 ) ) );
+		i128 += 1;
+	} // for
 	sout | nl;
 
@@ -186,8 +315,77 @@
 		ui128 += 1;
 	}
-}
+
+
+	// int128 constants (and printing)
+	int128 v = 0xffff_ffffffff_ffffffff_L128 + 0xffffffff_ffffffff_ffffffff_ffffffff_L128;
+	sout | hex(v);
+	v = 0xffff_ffffffff_ffffffff_L128 + 0xffffffff_ffffffff_ffffffff_ffffffff_L128;
+	sout | hex(v);
+	sout | nl;
+
+	sout | "binary";
+	sout | bin(v);
+	sout | bin(0b_11111111111111111111111111111111_L128);
+	sout | bin(0b_11111111111111111111111111111111_11111111111111111111111111111111_L128);
+	sout | bin(0b_11111111111111111111111111111111_11111111111111111111111111111111_11111111111111111111111111111111_L128);
+	sout | bin(0b_11111111111111111111111111111111_11111111111111111111111111111111_11111111111111111111111111111111_11111111111111111111111111111111_L128);
+	sout | hex(0b_10100010001101000101011001111000_L128);
+	sout | hex(0b_10100010001101000101011001111000_10100111011001010100001100100001_L128);
+	sout | hex(0b_10100010001101000101011001111000_10100111011001010100001100100001_11000010001101000101011001111000_L128);
+	sout | hex(0b_10100010001101000101011001111000_10100111011001010100001100100001_11000010001101000101011001111000_11010111010101010100001100100001_L128);
+	sout | nl;
+
+	sout | "octal";
+	sout | oct(v);
+	sout | oct(0_123456_L128u);
+	sout | oct(0_123456_65432_uL128);
+	sout | oct(0_123456_65432_34567_L128);
+	sout | oct(0_123456_65432_34567_76543_L128);
+	sout | oct(0_123456_65432_34567_76543_23456_L128);
+	sout | oct(0_123456_65432_34567_76543_23456_65432_L128);
+	sout | oct(0_123456_65432_34567_76543_23456_65432_34567_L128);
+	sout | oct(0_123456_65432_34567_76543_23456_65432_34567_76543_L128);
+	sout | oct(0_1111111111111111111L);
+	sout | oct(0_11111111111111111111L);
+	sout | oct(0_111111111111111111111L);
+	sout | nl;
+
+	sout | "decimal";
+	sout | v;
+	sout | 42_798_L128 | oct(42_798_L128);
+	sout | 1_402_432_282_L128 | oct(1_402_432_282_L128);
+	sout | 45_954_901_031_287_L128 | oct(45_954_901_031_287_L128);
+	sout | 1_505_850_196_993_244_515_L128 | oct(1_505_850_196_993_244_515_L128);
+	sout | 394_749_758_663_249_135_511_342_L128 | oct(394_749_758_663_249_135_511_342_L128);
+	sout | 12_935_154_696_204_706_112_391_834_394_L128 | oct(12_935_154_696_204_706_112_391_834_394_L128);
+	sout | 423_859_149_128_410_414_395_372_834_994_551_L128 | oct(423_859_149_128_410_414_395_372_834_994_551_L128);
+	sout | 13_889_016_598_639_747_063_234_935_497_057_631_587_L128 | oct(13_889_016_598_639_747_063_234_935_497_057_631_587_L128);
+	sout | 1234567890123456789_uL128;
+	sout | 1234567890123456789_L128u;
+	sout | 0x_7fffffff_ffffffff_ffffffff_ffffffff_L128;
+	sout | 0x_ffffffff_ffffffff_ffffffff_ffffffff_L128;
+	sout | 0x_80000000_00000000_00000000_00000000_L128;
+	unsigned int128 vv;
+	vv = 340282366920938463463374607431768211455_L128u;
+	sout | vv;
+	vv = 170141183460469231731687303715884105727_L128;
+	sout | vv;
+	sout | nl;
+
+	sout | "hexadecimal";
+	sout | hex(v);
+	sout | hex(0x_ffffffff_L128);
+	sout | hex(0x_ffffffff_ffffffff_L128);
+	sout | hex(0x_ffffffff_ffffffff_ffffffff_L128);
+	sout | hex(0xffffffff_ffffffff_ffffffff_ffffffff_L128);
+	sout | hex(0x_a2345678_L128);
+	sout | hex(0x_a2345678_b7654321_L128);
+	sout | hex(0x_a2345678_b7654321_c2345678_L128);
+	sout | hex(0x_a2345678_b7654321_c2345678_d7654321_L128);
+	sout | nl;
+} // main
 
 // Local Variables: //
 // tab-width: 4 //
-// compile-command: "cfa -Wall -Wextra amanipulatorsOutput3.cfa" //
+// compile-command: "cfa -Wall -Wextra manipulatorsOutput3.cfa" //
 // End: //